//+------------------------------------------------------------------+
//|                                            MTF_PLdot.mq4          |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"

// Portions of this code are from #MTF_Moving_Average and DGBL
// Tweaked by pinoytrader

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Silver
#property indicator_color2 Blue
#property indicator_color3 Silver

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame=1440;
extern int MAPeriod=3;
extern int ma_shift=0;
extern int ma_method=MODE_SMA;
extern int applied_price=PRICE_TYPICAL;
//extern int envelope=233;

//double ExtMapBuffer1[];
//double ExtMapBuffer2[];
//double ExtMapBuffer3[];
double up[];
double md[];
double dn[];
double sup[];
double res[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   IndicatorBuffers(5);
   
   SetIndexBuffer(0,up);
   SetIndexBuffer(1,md);
   SetIndexBuffer(2,dn);
   SetIndexBuffer(3,res);
   SetIndexBuffer(4,sup);
   
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexShift(0,1);
   SetIndexShift(1,1);
   SetIndexShift(2,1);
  
  /* SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE);   */
   
//---- name for DataWindow and indicator subwindow label   
   switch(ma_method)
     {
      case 1 : short_name="MTF_EMA("; break;
      case 2 : short_name="MTF_SMMA("; break;
      case 3 : short_name="MTF_LWMA("; break;
      default : short_name="MTF_SMA(";
     }
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   IndicatorShortName(short_name+MAPeriod+") "+TimeFrameStr);  
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF Moving Average                                   |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   ArraySetAsSeries(sup,true);
   ArraySetAsSeries(res,true);
   
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
   {
      sup[y] = (((iHigh(NULL,TimeFrame,y)+iLow(NULL,TimeFrame,y)+iClose(NULL,TimeFrame,y))*2)/3)-iHigh(NULL,TimeFrame,y);
      res[y] = (((iHigh(NULL,TimeFrame,y)+iLow(NULL,TimeFrame,y)+iClose(NULL,TimeFrame,y))*2)/3)-iLow(NULL,TimeFrame,y);
   }
   }
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   {
      
      up[i] = iMAOnArray(res,0,3,0,MODE_SMA,y);
      md[i] = iMA(NULL,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price,y);
      dn[i] = iMAOnArray(sup,0,3,0,MODE_SMA,y);
   }

  /* ExtMapBuffer1[i]=iMA(NULL,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price,y) ; 
   ExtMapBuffer2[i]=ExtMapBuffer1[i]+(envelope*Point) ;
   ExtMapBuffer3[i]=ExtMapBuffer1[i]-(envelope*Point) ;*/
   
   
   }
     
//
   
  
  
   return(0);
  }
//+------------------------------------------------------------------+


